diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererDefault.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererDefault.java
index 76b04542b..68f357952 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererDefault.java
@@ -2,13 +2,14 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
 public class EntityRendererDefault extends EntityRenderer<Entity>
 {
     @Override
-    public void render(Tessellator tessellator, Entity entity, double x, double y, double z,
-                       float yaw, float partialTick)
+    public void render(@NotNull final Tessellator tessellator, @NotNull final Entity entity, final double x, final double y, final double z,
+                       final float yaw, final float partialTick)
     {
         GL11.glPushMatrix();
         renderOffsetAABB(tessellator, entity.bb, x - entity.xo, y - entity.yo, z - entity.zo);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
index dac540d6e..47ef9d12c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
@@ -12,6 +12,7 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.EntityFallingBlock;
 import net.minecraft.core.world.BlocksContainer;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
 public class EntityRendererFallingBlock extends EntityRenderer<EntityFallingBlock>
@@ -27,7 +28,7 @@ public class EntityRendererFallingBlock extends EntityRenderer<EntityFallingBloc
     }
 
     @Override
-    public void render(Tessellator tessellator, EntityFallingBlock fallingBlock, double x, double y, double z, float yaw, float partialTick) {
+    public void render(@NotNull Tessellator tessellator, @NotNull EntityFallingBlock fallingBlock, double x, double y, double z, float yaw, float partialTick) {
         if (container == null || container.world != fallingBlock.world) {
             container = new BlocksContainer(fallingBlock.world);
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
index 7b4692e63..70f69f443 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.EntityFishingBobber;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 public class EntityRendererFishingBobber extends EntityRendererSprite<EntityFishingBobber>
 {
@@ -14,7 +15,7 @@ public class EntityRendererFishingBobber extends EntityRendererSprite<EntityFish
     }
 
     @Override
-    public void render(Tessellator tessellator, EntityFishingBobber entity, double x, double y, double z, float yaw, float partialTick) {
+    public void render(@NotNull Tessellator tessellator, @NotNull EntityFishingBobber entity, double x, double y, double z, float yaw, float partialTick) {
         super.render(tessellator, entity, x, y, z, yaw, partialTick);
         if(entity.owner != null)
         {
@@ -28,7 +29,7 @@ public class EntityRendererFishingBobber extends EntityRendererSprite<EntityFish
             double xp = entity.owner.xo + (entity.owner.x - entity.owner.xo) * (double)partialTick + vec3.x;
             double yp = entity.owner.yo + (entity.owner.y - entity.owner.yo) * (double)partialTick + vec3.y;
             double zp = entity.owner.zo + (entity.owner.z - entity.owner.zo) * (double)partialTick + vec3.z;
-            if(renderDispatcher.gameSettings.thirdPersonView.value > 0)
+            if(renderDispatcher.settings.thirdPersonView.value > 0)
             {
                 float rr = ((entity.owner.yBodyRotO + (entity.owner.yBodyRot - entity.owner.yBodyRotO) * partialTick) * MathHelper.PI) / 180F;
                 double ss = MathHelper.sin(rr);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererGeneric.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererGeneric.java
new file mode 100644
index 000000000..c64d1ed24
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererGeneric.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.render.entity;
+
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.entity.Entity;
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.opengl.GL11;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
+
+public class EntityRendererGeneric<T extends Entity> extends EntityRenderer<T>{
+    public final @NotNull StaticEntityModel entityModel;
+    public EntityRendererGeneric(final @NotNull StaticEntityModel entityModel, final float shadowSize) {
+        super();
+        this.shadowSize = shadowSize;
+        this.entityModel = entityModel;
+    }
+    @Override
+    public void render(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        GL11.glPushMatrix();
+        bindTexture("/assets/minecraft/textures/entity/creeper/0.png");
+        GL11.glTranslated(x, y, z);
+        this.entityModel.resetBones();
+        this.entityModel.render(tessellator);
+        GL11.glPopMatrix();
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
index 98eb6efcc..a4d01df79 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.entity.EntityItem;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.render.LightmapHelper;
@@ -10,8 +11,6 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
-import org.lwjgl.opengl.GL12;
-import org.useless.dragonfly.DisplayPos;
 
 import static org.lwjgl.opengl.GL11.glPushMatrix;
 
@@ -24,7 +23,7 @@ public class EntityRendererItem extends EntityRenderer<EntityItem>
 		shadowOpacity = 0.75F;
 	}
 
-	public void render(Tessellator tessellator, final EntityItem entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+	public void render(@NotNull Tessellator tessellator, final @NotNull EntityItem entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
 		float brightness = 1.0f;
 		if(!LightmapHelper.isLightmapEnabled()) {
 			brightness = entity.getBrightness(partialTick);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
index 24f68064b..e77c83682 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
@@ -4,6 +4,7 @@ import java.util.Random;
 
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.EntityLightning;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
 public class EntityRendererLightningBolt extends EntityRenderer<EntityLightning>
@@ -14,7 +15,7 @@ public class EntityRendererLightningBolt extends EntityRenderer<EntityLightning>
     }
 
     @Override
-    public void render(Tessellator tessellator, EntityLightning lightning, double x, double y, double z,
+    public void render(@NotNull Tessellator tessellator, @NotNull EntityLightning lightning, double x, double y, double z,
                        float yaw, float partialTick)
     {
         GL11.glDisable(GL11.GL_TEXTURE_2D);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
index a937cccf0..5c0f563c8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
@@ -2,8 +2,6 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.model.ModelBase;
-import net.minecraft.client.render.model.ModelMinecart;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
@@ -12,22 +10,25 @@ import net.minecraft.core.Global;
 import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
 
 public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
     public EntityRendererMinecart() {
-        shadowSize = 0.5F;
-        modelMinecart = new ModelMinecart();
+        super();
+        this.shadowSize = 0.5F;
     }
 
     @Override
-    public void render(Tessellator tessellator, EntityMinecart minecart, final double x, final double y, final double z, final float yaw, final float partialTick) {
+    public void render(@NotNull final Tessellator tessellator, @NotNull final EntityMinecart minecart, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GL11.glPushMatrix();
-        
-        double lerpX = MathHelper.lerp(minecart.xo, minecart.x, partialTick);
-        double lerpY = MathHelper.lerp(minecart.yo, minecart.y, partialTick);
-        double lerpZ = MathHelper.lerp(minecart.zo, minecart.z, partialTick);
-        Vec3 vec3 = minecart.getPos(lerpX, lerpY, lerpZ); // Opposite of velocity vector?
+
+        final double lerpX = MathHelper.lerp(minecart.xo, minecart.x, partialTick);
+        final double lerpY = MathHelper.lerp(minecart.yo, minecart.y, partialTick);
+        final double lerpZ = MathHelper.lerp(minecart.zo, minecart.z, partialTick);
+        final Vec3 vec3 = minecart.getPos(lerpX, lerpY, lerpZ); // Opposite of velocity vector?
         double lerpXRot = MathHelper.lerp(minecart.xRotO, minecart.xRot, partialTick);
 
         double renderX = x;
@@ -60,7 +61,7 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
                 lerpXRot = Math.atan(velVec.y) * 73D;
             }
 
-            Vec3 realVecVec = Vec3.getTempVec3(minecart.xd, minecart.yd, minecart.zd);
+            final Vec3 realVecVec = Vec3.getTempVec3(minecart.xd, minecart.yd, minecart.zd);
 
             doAFlip = velVec.dotProduct(realVecVec) < 0;
 
@@ -69,7 +70,7 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
         GL11.glTranslated(renderX, renderY, renderZ);
         GL11.glRotated(180F - renderYaw, 0.0F, 1.0F, 0.0F);
         GL11.glRotated(-lerpXRot, 0.0F, 0.0F, 1.0F);
-        double hurtAngle = minecart.timeSinceHit - partialTick;
+        final double hurtAngle = minecart.timeSinceHit - partialTick;
         double currentDamage = minecart.currentDamage - partialTick;
         if(currentDamage < 0.0F) {
             currentDamage = 0.0F;
@@ -97,7 +98,7 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
             }
             switch (minecart.getType()){
                 case EntityMinecart.CHEST_CART:
-                    Block<?> block;
+                    final Block<?> block;
                     if ((minecart.getMeta() & 0b0000_0001) != 0) {
                         block = Blocks.CHEST_PLANKS_OAK_PAINTED;
                     } else {
@@ -119,12 +120,12 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
             GL11.glScalef(1.0F / scale, 1.0F / scale, 1.0F / scale);
         }
         bindTexture("/assets/minecraft/textures/entity/cart.png");
-        GL11.glScalef(-1F, -1F, 1.0F);
-        modelMinecart.render(null, 0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.0625F, partialTick);
+        GL11.glScalef(1/16f, 1/16f, -1/16f);
+        getModel("main").render(tessellator);
         GL11.glPopMatrix();
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
-
-    private void drawDebugVec(Tessellator tessellator, Vec3 pos, Vec3 vec, double scale, float r, float g, float b, float a){
+    private static void drawDebugVec(final Tessellator tessellator, final Vec3 pos, final Vec3 vec, final double scale, final float r, final float g, final float b, final float a){
         if (pos == null || vec == null) return;
         GL11.glLineWidth(10);
         GL11.glDisable(GL11.GL_LIGHTING);
@@ -140,5 +141,4 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
         GL11.glEnable(GL11.GL_TEXTURE_2D);
         GL11.glEnable(GL11.GL_LIGHTING);
     }
-    protected ModelBase modelMinecart;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java
index cc2f8da3b..00cddbbf7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java
@@ -10,6 +10,7 @@ import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 
@@ -125,7 +126,7 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting>
         {
             worldZ = MathHelper.floor(entity.z + (double)(centerX / 16F));
         }
-        float brightness = renderDispatcher.world.getLightBrightness(worldX, worldY, worldZ);
+        float brightness = entity.world.getLightBrightness(worldX, worldY, worldZ);
         if (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) {
             LightmapHelper.setLightmapCoord(entity.world.getLightmapCoord(worldX, worldY, worldZ, entity.world.getBlockLightValue(worldX, worldY, worldZ)));
         	brightness = 1.0f;
@@ -134,7 +135,7 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting>
     }
 
     @Override
-    public void render(Tessellator tessellator, EntityPainting entity, double x, double y, double z, float yaw, float partialTick) {
+    public void render(@NotNull Tessellator tessellator, @NotNull EntityPainting entity, double x, double y, double z, float yaw, float partialTick) {
         rand.setSeed(187L);
         GL11.glPushMatrix();
         GL11.glTranslatef((float)x, (float)y, (float)z);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java
index a97975654..f513d37cb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 
@@ -33,7 +34,7 @@ public class EntityRendererSprite<T extends Entity> extends EntityRenderer<T>
     }
 
     @Override
-    public void render(Tessellator tessellator, T entity, double x, double y, double z,
+    public void render(@NotNull Tessellator tessellator, @NotNull T entity, double x, double y, double z,
                        float yaw, float partialTick)
     {
         GL11.glPushMatrix();
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
index 22606bde2..0055535fd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
@@ -7,6 +7,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.EntityPrimedTNT;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Blocks;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
 public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT>
@@ -17,7 +18,7 @@ public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT>
     }
 
     @Override
-    public void render(Tessellator tessellator, EntityPrimedTNT tnt, double x, double y, double z, float yaw, float partialTick)
+    public void render(@NotNull Tessellator tessellator, @NotNull EntityPrimedTNT tnt, double x, double y, double z, float yaw, float partialTick)
     {
         GL11.glPushMatrix();
         GL11.glTranslatef((float)x, (float)y, (float)z);
